Subject: Re: [PATCH RFC 00/22] EEH Support for VFIO PCI devices on PowerKVM guest

From: Alexander Graf <[email-masked]>
Date: Mon, 05 May 2014 13:56:28 +0200

On 05/05/2014 03:27 AM, Gavin Shan wrote:
> The series of patches intends to support EEH for PCI devices, which have been
> passed through to PowerKVM based guest via VFIO. The implementation is
> straightforward based on the issues or problems we have to resolve to support
> EEH for PowerKVM based guest.
>
> - Emulation for EEH RTAS requests. Thanksfully, we already have infrastructure
>    to emulate XICS. Without introducing new mechanism, we just extend that
>    existing infrastructure to support EEH RTAS emulation. EEH RTAS requests
>    initiated from guest are posted to host where the requests get handled or
>    delivered to underly firmware for further handling. For that, the host kerenl
>    has to maintain the PCI address (host domain/bus/slot/function to guest's
>    PHB BUID/bus/slot/function) mapping via KVM VFIO device. The address mapping
>    will be built when initializing VFIO device in QEMU and destroied when the
>    VFIO device in QEMU is going to offline, or VM is destroy.

Do you also expose all those interfaces to user space? VFIO is as much 
about user space device drivers as it is about device assignment.

I would like to first see an implementation that doesn't touch KVM 
emulation code at all but instead routes everything through QEMU. As a 
second step we can then accelerate performance critical paths inside of KVM.

That way we ensure that user space device drivers have all the power 
over a device they need to drive it.

Alex